#!/usr/bin/perl
# $Id: digits2c.pl,v 2.1 1995/06/24 19:37:15 ssd Exp ssd $

require "getopt.pl";

&Getopt("btn");

# options:
#  -s	sort colors
#  -b #	background color
#  -t #	transparent color
#  -n #	number of bits to keep in each color

# arguments
#   basefilename%d
#   identifier
#   converter

$color=0;

sub handler {
  local($sig)=@_;
  &cleanup("Caught signal $sig--cleaning up.\n");
}

sub cleanup {
  unlink("$ident.c","$ident.h");
  die @_;
}

if ( $#ARGV < 1){
  die "Usage: digits2c basefilename%d identifier [converter]\n";
}

$base = shift @ARGV;
$ident = shift @ARGV;
if (@ARGV) {
  $converter = shift @ARGV;
  $converter .= '|'  if ($converter !~ /\|$/);
}

open(FC,">$ident.c") || &cleanup("couldn't open $ident.c: $!\n");
open(FH,">$ident.h") || &cleanup("couldn't open $ident.h: $!\n");

print FC "/* $ident font */\n\n";
print FH "/* $ident font */\n\n";

# read in the images, save the colors
for ($i=0; $i<10; $i++){
  $name = sprintf($base,$i);
  warn "$name\n";
  if (defined($converter)){
    $p = sprintf($converter,$name);
    open(D,$p) || &cleanup("can't convert $name: $!\n");
  } else {
    open(D,$name) || &cleanup("can't open $name: $!\n");
  }
# read pgm header
#   this code only accepts pgm binary format
#   skip any comments after the first header line
#   read colormap size on same or separate line
  $_=<D>;
  chop;
  &cleanup("Not pgm binary?!?\n") if (!/^P5$/);
  while (<D>){
    last if (!/^#/);
  }
  ($w, $h, $c) = split(' ');
  $_ = <D> if (!$c);

# sanity checks
  if ($i == 0){
    $width = $w;
    $height = $h;
  } elsif ($w != $width || $h != $height) {
    warn "Digit $i is ($w,$h) instead of ($width,$height).\n";
  }

  $m = read(D,$data, $w * $h);
  warn "read only $h for $w*$h" if ($m != $w*$h);
  close(D);

# write out the data
  print FH "extern unsigned char $ident$i[];\n";
  print FC "unsigned char $ident$i[] = {\n";
  @x = unpack("C*",$data);
  for ($j=0;$j<=$#x;$j++){
    if (defined($colormap{$x[$j]})) {
  	$x[$j] = $colormap{$x[$j]};
    } else {
  	$x[$j] = $colormap{$x[$j]} = $color++;
    }
  }
  while (@x){
    print FC "   ",join(", ",splice(@x,0,$width)),",\n";
  }
  print FC "};\n\n";
}


for ($i=0; $i<10; $i++){
  $name = sprintf($base,$i);
  warn "$name\n";
  if (defined($converter)){
    $p = sprintf($converter,$name);
    open(D,$p) || &cleanup("can't convert $name: $!\n");
  } else {
    open(D,$name) || &cleanup("can't open $name: $!\n");
  }
# read pgm header
#   this code only accepts pgm binary format
#   skip any comments after the first header line
#   read colormap size on same or separate line
  $_=<D>;
  chop;
  &cleanup("Not pgm binary?!?\n") if (!/^P5$/);
  while (<D>){
    last if (!/^#/);
  }
  ($w, $h, $c) = split(' ');
  $_ = <D> if (!$c);

# sanity checks
  if ($i == 0){
    $width = $w;
    $height = $h;
  } elsif ($w != $width || $h != $height) {
    warn "Digit $i is ($w,$h) instead of ($width,$height).\n";
  }

  $m = read(D,$data, $w * $h);
  warn "read only $h for $w*$h" if ($m != $w*$h);
  close(D);

# write out the data
  print FH "extern unsigned char $ident$i[];\n";
  print FC "unsigned char $ident$i[] = {\n";
  @x = unpack("C*",$data);
  for ($j=0;$j<=$#x;$j++){
    if (defined($colormap{$x[$j]})) {
  	$x[$j] = $colormap{$x[$j]};
    } else {
  	$x[$j] = $colormap{$x[$j]} = $color++;
    }
  }
  while (@x){
    print FC "   ",join(", ",splice(@x,0,$width)),",\n";
  }
  print FC "};\n\n";
}

print FH "
#define ${ident}_width  $width
#define ${ident}_height  $height
#define ${ident}_maxcolor $color

extern unsigned char ${ident}_greymap[];

#define ${ident}_red ${ident}_greymap
#define ${ident}_green ${ident}_greymap
#define ${ident}_blue ${ident}_greymap
";

print FC "unsigned char ${ident}_greymap[] = {\n";
print FC join(", ",sort { $colormap{$a} <=> $colormap{$b};} keys %colormap),"\n};\n";
