/* $Id: image2c.c,v 2.1 1995/06/24 19:37:15 ssd Exp ssd $ */
/*  Copyright May, 1995 by Steven Dick <ssd@mae.engr.ucf.edu>
 *  Copy freely; send me e-mail so I can inform you of updates;
 *  let me know of any interesting changes you make.
 */

#include <stdio.h>

void usage()
{
  fprintf(stderr,"Usage: image2c imagefile ident\n");
  exit(1);
}

int
main(int argc, char *argv[])
{
  FILE *fc, *fh, *in;
  unsigned char buf[1024], *s;
  int i,j,tot;

  if (argc<3)
    usage();

  if (argv[1][0]=='-' && argv[1][1]==0)
    in = stdin;
  else
    in = fopen(argv[1],"r");
  if (!in){
    sprintf(buf,"Couldn't open %s",argv[1]);
    perror(buf);
    exit(1);
  }

  sprintf(buf,"%s.c",argv[2]);
  fc = fopen(buf,"w");
  if (!fc) {
    sprintf(buf,"Couldn't open %s.c",argv[2]);
    perror(buf);
    exit(2);
  }
  sprintf(buf,"%s.h",argv[2]);
  fh = fopen(buf,"w");
  if (!fh) {
    sprintf(buf,"Couldn't open %s.h",argv[2]);
    perror(buf);
    exit(3);
  }

  fprintf(fc,"/* %s */\n\nunsigned char %s[] = {\n",argv[2],argv[2]);
  fprintf(fh,"/* %s */\n\nextern unsigned char %s[];\n",argv[2],argv[2]);
  j=75;
  tot = i = fread(buf,1,1024,in);
  s = buf;
  while (i>0){
    while (i && j>0){
      j -= 3;
      if (*s > 9) j--;
      if (*s > 99) j--;
      fprintf(fc,"%d, ",*s++);
      i--;
    }
    if (j<=0){
      j=75;
      putc('\n',fc);
    }
    if (!i){
      i = fread(buf,1,1024,in);
      if (i>0) tot += i;
      s = buf;
    }
  }
  fprintf(fc,"\n};\n");
  fclose(fc);
  fprintf(fh,"#define %s_size %d\n",argv[2],tot);
  fclose(fh);
  return 0;
}

